module Ubc.Parse.Syntax.Import
(
parse)
where

import Text.Parsec (sepBy1, ParsecT, anyChar, many, char, choice, notFollowedBy, oneOf)

import OsPath as OsPath

import qualified Ubc.Parse.Syntax.Language as UbcLanguage
import System.OsPath (encodeUtf, OsPath)
import System.OsPath.Encoding (EncodingException (EncodingError))
import Control.Exception (SomeException(SomeException))

importPath :: Monad m => ParsecT String u m [String]
importPath = UbcLanguage.angles (many importChar `sepBy1` char '/')

importChar :: (Monad m) => ParsecT String u m Char
importChar = choice
        [ char '\\' >> oneOf ">/\\"
        , notFollowedBy (oneOf ">/") >> anyChar
        ]

parse :: ParsecT String u IO [String]
parse = do
        UbcLanguage.reserved "import"
        fragments <- importPath
        case mapM encodeUtf fragments :: Either EncodingException [OsPath] of
                Left err -> pure ()
                Right success -> pure ()

        pure []

